package lecture1

class MyThread(val sleepiness: Int) extends Thread:
  override def run: Unit =
    var i: Int = 0
    while i < 6 do
      println("Thread" + getName + " has counter " + i)
      i = i + 1
      Thread.sleep(sleepiness)

@main def testThreads: Unit =
  val t1 = MyThread(2)
  val t2 = MyThread(3)
  println("Little threads did not start yet!")
  t1.start
  t2.start
  Thread.sleep(4)
  println("Parent thread and children are running!")
  Thread.sleep(29)
  t1.join()
  t2.join()
  println("Main thread ending.")
